﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace _2010_11_09_EnableXamOutlookBar
{


    public enum EntityType
    {
        Project,
        Contract,
        ContractDt,
        Lease,
        LeaseDt,
        Well,
        WellDt,
        Party,
        Operator,
        Prospect,
        Property,
        Field,
        Defect,
        Obligation,
        Payout
    }

    public class ProjectExplorerNode : INotifyPropertyChanged
    {

        //http://blogs.infragistics.com/blogs/curtis_taylor/archive/2010/06/23/control-monster-explores-multi-level-xamtrees-part-i.aspx

        Guid _id;
        EntityType _nodeType;
        int _itemCount;
        string _objectName;
        string _objectNumber;
        Guid? _prj_Id;
        Guid? _parent_Id;
        EntityType _parentType;
        bool _isGroupNode;

        public ProjectExplorerNode() { }

        public ProjectExplorerNode(Guid id, EntityType eType, int count, string name, string number, Guid? prj_Id, Guid? parentId, EntityType eParent, bool isGroup)
        {
            _id = id;
            _nodeType = eType;
            _itemCount = count;
            _objectName = name;
            _objectNumber = number;
            _prj_Id = prj_Id;
            _parent_Id = parentId;
            _parentType = eParent;
            _isGroupNode = isGroup;
        }

        public Guid Id
        {
            get { return _id; }
            set { _id = value; }
        }

        public EntityType NodeType
        {
            get { return _nodeType; }
            set { _nodeType = value; }
        }

        public int ItemCount
        {
            get { return _itemCount; }
            set { _itemCount = value; }
        }

        public string ObjectName
        {
            get { return _objectName; }
            set { _objectName = value; }
        }

        public string ObjectNumber
        {
            get { return _objectNumber; }
            set { _objectNumber = value; }
        }

        public Guid? Prj_Id
        {
            get { return _prj_Id; }
            set { _prj_Id = value; }
        }

        public Guid? Parent_Id
        {
            get { return _parent_Id; }
            set { _parent_Id = value; }
        }

        public EntityType ParentType
        {
            get { return _parentType; }
            set { _parentType = value; }
        }

        public bool IsGroupNode
        {
            get { return _isGroupNode; }
            set { _isGroupNode = value; }
        }




        public string HeaderText
        {
            get
            {
                string header = "";
                if (_objectNumber != null)
                {
                    if (_objectName != null)
                    {
                        header = _objectName;
                    }
                    else
                    {
                        header = _objectNumber;
                    }
                }
                if (_objectName != null)
                {
                    header = _objectName;
                }
        
                return header;
            }
        }





        //public ObservableCollection<ProjectExplorerNode> Children
        //{
        //    get { return _children; }
        //    set { _children = value; OnPropertyChanged("Children"); }
        //}


        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }




    }
}

